<?
/************************************************************************/
/*		dhcp_lib.php						*/
/*									*/

/* variables globales */
/* plage des adresses dynamiques */

$dyn_first_int=0;
$dyn_last_int=0;

/* retourne une adresse ip formate en compltant par des zros  gauche */
/* pour chaque octet sur 3 caractres */
/* sinon, retourne chaine vide */
function format_ip($ch_ip)
{
	$ip_retour="";
	$tab_ip=explode('.',$ch_ip); /* transforme l'adresse ip en tableau de 4 chaines */
	if ( count($tab_ip) <> 4 )
	{
		print("<H3>Attention : une adresse ip doit avoir la forme xxx.xxx.xxx.xxx</H3>");
		return("");
	}
	else
	{
		for ($i=0; $i <4; $i++)
		{ while ( strlen($tab_ip[$i])<3 )
			$tab_ip[$i]='0'.$tab_ip[$i];
	  	$ip_retour=$ip_retour.$tab_ip[$i];
	  	if ( $i <3 )
			$ip_retour=$ip_retour.'.'; /* on ajoute un point sauf au dernier */		
		}
		return($ip_retour);
	}
}

/* retourne une adresse MAC formate en compltant par des zros  gauche */
/* pour chacun des 6 octets sur 2 caractres */
/* sinon retourne chaine vide */

function format_mac($ch_mac)
{
	$ch_mac=strtoupper($ch_mac);
	$mac_retour="";
	$tab_mac=explode(':',$ch_mac); /* transforme l'adresse mac en tableau de 4 chaines */
	if ( count($tab_mac) <> 6 )
	{
		$z=count($tab_mac);
		print("<H3>Attention : une adresse mac doit avoir la forme xx:xx:xx:xx:xx:xx</H3>");
		return("");
	}	
	else
	{
		for ($i=0; $i <6; $i++)
		{ while ( strlen($tab_mac[$i])<2 )
				$tab_mac[$i]='0'.$tab_mac[$i];
	  	$mac_retour=$mac_retour.$tab_mac[$i];
	  	if ( $i <5 )
			$mac_retour=$mac_retour.':'; /* on ajoute un point sauf au dernier */		
		}
				/* vrification caractres valides */
		if ( ! ereg("[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}",$mac_retour,$tab_err) )
		{
        		print("<H3>Caractres interdits dans $mac_retour<H3>");
        		return("");
  		}

		return($mac_retour);
	}
}

/********************************************************/
/* validation adresse MAC : retourne vrai si ok		*/
/* retourne faux et message d'erreur sinon		*/
/********************************************************/
function valid_mac($mac)
{
  	$tab_mac=explode(':',$mac); /* transforme adresse mac en tableau de 6 octets */
  	if ( count($tab_mac)<>6)
	{
		print("<H3>Attention : une adresse MAC doit avoir la forme xx:xx:xx:xx:xx:xx</H3>");
		return(0);
	}
	$mac=strtoupper($mac);
	$l=strlen($mac);
	for ($i=0; $i <$l; $i++)
	{
		$c=substr($mac,$i,1);
		if ( ! ereg("[A-F0-9:]",$c,$tab_err) )
		{ print ("caractre $c incorrect dans adresse mac $mac <P> ");
		    return 0;
		}
	}
	return 1;
}
/********************************************************/
/* validation adresse ip : retourne vrai si ok		*/
/* retourne faux et message d'erreur sinon		*/
/********************************************************/
function valid_ip($ip)
{
 	$tab_ip=explode('.',$ip); /* transforme l'adresse ip en tableau de 4 chaines */
	if ( count($tab_ip) <> 4 )
	{
		print("<H3>Attention : une adresse ip doit avoir la forme xxx.xxx.xxx.xxx</H3>");
		return(0);
	}
	for ($i=0; $i <4; $i++)
	{
		$octet= $tab_ip[$i];
		$l=strlen($octet);
		for ($j=0; $j <$l; $j++)
		{
			$c=substr($octet,$j,1);
			if ( ! ereg("[0-9]",$c,$tab_err) )
			{ print ("caractre $c incorrect dans $ip octet $octet<P> ");
			  return 0;
			}
		}
                $z=(int)$octet;
		if ( ( $z > 255 ) || ( $z < 0 ) )
		{
			$i++;
			print (" <P>dans adresse ip $ip :  octet $octet incorrect ");
			return(0);
		}
	}
	return 1;
}
/********************************************************/
/*	validation hostname selon RFC 2181		*/
/* Le nom n'est pas case sensitive			*/
/* 63 caractres maxi 1 caractre mini			*/
/* il commence par une lettre "A-Z" ou 1 chiffre	*/
/* il finit par une lettre ou un chiffre		*/
/* il peut contenir un tiret '-'			*/
/*******************************************************/
function valid_name($nom)
{
	$nom=strtoupper($nom);
	$l=strlen($nom);
	if ( $l == 0 )
	{
		print ("le nom doit contenir au moins une lettre<P>");
		return 0;
	}
	if ( $l > 63 )
	{
		print ("le nom $nom ne doit pas dpasser 63 caractres<P>");
		return 0;
	}
	for ($i=0; $i <$l; $i++)
	{
		$c=substr($nom,$i,1);
		if ( ! ereg("[A-Z0-9-]",$c,$tab_err) )
		{ print ("caractre $c incorrect dans hostname $nom <P> ");
		    return 0;
		}
	}
	$prem=substr($nom,O,1);
	if ( ! ereg("[A-Z0-9]",$prem,$tab_err) )
	{
		print ("le nom $nom doit commencer par une lettre ou un chiffre<P>");
		return 0;
	}
	
	$der=substr($nom,$l-1,1);
	if ( ! ereg("[A-Z0-9]",$der,$tab_err) )
	{
		print ("le nom $nom doit finir par une lettre ou un chiffre<P>");
		return 0;
	}
	
	return 1;
  	
}
/************************************************************************/
/* validation adresse liste d'adresses ip : retourne vrai si ok		*/
/* retourne faux et message d'erreur sinon				*/
/* la liste doit tre une suite d'adresses ip spares par un espace	*/
/************************************************************************/
function valid_liste_ip($liste_ip)
{
 	$tab_ip=explode(' ',$liste_ip); /* transforme la liste d'adresses ip en tableau d'adresses */
	$nb_ip=count($tab_ip);
	for ( $i=0;$i<$nb_ip;$i++ )
	{
		$ip=$tab_ip[$i];
		if ( ! valid_ip($ip) )
		{
			print("adresse ip $ip incorrect<P>");
			return 0;
		}
	}
  	return 1;
}
/************************************************************************/
/* validation liste hostname : retourne vrai si ok			*/
/* retourne faux et message d'erreur sinon				*/
/* la liste doit tre une suite de noms de host spars par un espace	*/
/************************************************************************/
function valid_list_name($liste_name)
{
	$liste_name=trim($liste_name);   /* supprime espaces  droite et  gauche */
	if ($liste_name == "" ) return 1;
 	$tab_name=explode(' ',$liste_name); /* transforme la liste de noms en tableau de noms */
	$nb_name=count($tab_name);
	for ( $i=0;$i<$nb_name;$i++ )
	{
		$name=$tab_name[$i];
		if ( ! valid_name($name) )
		{
			print("nom $name incorrect<P>");
			return 0;
		}
	}
  	return 1;
}


/***********  rcuprer la plage ip dynamique si elle existe ***********/
/***********  la plage est stocke dans les variables globales   *******/
/*********** $dyn_first et  $dyn_last_int                        *******/

function plage_dynamique($database)
{
global $dyn_first_int;
global $dyn_last_int;

$dyn_first_int=0;
$dyn_last_int=0;

$v_query=@pg_exec($database,"select attname from pg_attribute where attname ='dyn_first'; ");
$v_count=pg_numrows($v_query);
if ( $v_count <> 0 )
	{
		$v_query=pg_exec($database,"select rtrim(dyn_first),rtrim(dyn_last) from param");
		$row=pg_fetch_row($v_query,0);
		$dyn_first=$row[0];
		$dyn_last=$row[1];
	
		if ( $dyn_first <> "" )
			$dyn_first_int=ip2long($dyn_first);
		if ( $dyn_last <> "")
			$dyn_last_int=ip2long($dyn_last);
	}
}

/* traite un tableau de lignes d'adresses */
/* pour les insrer dans la table matriel */
/* au passage, les adresses ip sont formates : 192.168.173.1 devient 192.168.173.001 */
function traite_tableau($tableau,$database,$separ)
{
	/* rcuprer la plage dynamique si elle existe */
	global $dyn_first_int;
	global $dyn_last_int;

	plage_dynamique($database);	

	$nb_lignes=count($tableau);
	print ("<P>Nombre de lignes reues : $nb_lignes");
  	print ("<P>Traitement en cours ...");
  	flush(); /* force l'affichage avant la fin de la page */

	/* nettoyage de la table des adresses occupes */
	$v_query=pg_exec($database,"begin work");
	$v_query=pg_exec($database,"delete from materiel;");

	/* insertion des lignes du tableau */	
	$z=0;
	$erreur=0;  /* si erreur est vrai en sortie de boucle, annuler transaction */

	$faux_nom=1;    /* si jamais le nom n'est pas renseign, on l'invente */
			/* avec un numro */
	while ($z < $nb_lignes )
	{
	/* sauter ventuelle ligne vide */
	/* c'est souvent le cas pour la dernire ligne du presse-papier */
	if ($tableau[$z] == "" )
		break;
	/* dcoupage de chaque ligne  partir du sparateur | */
  	$tab_ligne=explode($separ,$tableau[$z]);
  	$ip=$tab_ligne[0];
  	if ( ! valid_ip($ip) )
  		{
  		  print("<P><B>Erreur sur adresse ip : $tab_ligne[0] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}
  	
  	$ip=format_ip($ip);
  		if ( $ip == "" )
  		{
  		  print("<P><B>Erreur sur adresse ip : $tab_ligne[0] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}
  	$nom=$tab_ligne[1];
  	if ( ! valid_name($nom) )
  		{
  		  print("<P><B>Erreur sur hostname : $tab_ligne[1] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	
  	$mac=$tab_ligne[2];
  	if ( ! valid_mac($mac) )
  		{
  		  print("<P><B>Erreur sur adresse mac : $tab_ligne[2] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	
  	$mac=format_mac($mac);
  		if ( $mac == "" )
  		{
  		  print("<P><B>Erreur sur adresse mac : $tab_ligne[2] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	$alias=$tab_ligne[3];
	$alias=trim($alias);   /* supprime espaces  droite et  gauche */
  	if ( $alias <> "" )
  	{
  		if ( ! valid_list_name($alias) )
  		{
  		  print("<P><B>Erreur sur alias : *$alias* </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}
  	}  	
  	
  	/* vrifier doublons ventuels */
	$v_query=pg_exec($database,"select * from materiel where ip='$ip'");
	$v_count=pg_numrows($v_query);
	if ($v_count <> 0)
	{
		print("<H2> adresse ip $ip dja prise </H2>");
  		$ligne=$z+1;
  		print("<P><B>Numro de ligne $ligne");
  		$erreur=1;
  		break;
	}
	$v_query=pg_exec($database,"select * from materiel where mac='$mac'");
	$v_count=pg_numrows($v_query);
	if ($v_count <> 0)
	{
		print("<H2> adresse mac $mac dja prise </H2>");
  		$ligne=$z+1;
  		print("<P><B>Numro de ligne $ligne");
  		$erreur=1;
  		break;
	}

	/* vrifier si ip prsent dans la plage des disponibles */
	$v_query=pg_exec($database,"select * from reseau where ip='$ip'");
	$v_count=pg_numrows($v_query);
	if ($v_count == 0)
	{
		print("<H2> L'adresse $ip n'est pas dans la plage disponible </H2>");
  		$ligne=$z+1;
  		print("<P><B>Numro de ligne $ligne");
  		$erreur=1;
  		break;
	}

	if ( $nom == "" )
	{
		$nom="X".$faux_nom;
		$faux_nom++;
	}
	if ( ! valid_name($nom) )
	{
		print("<H2> Nom $nom incorrect </H2>");
  		$ligne=$z+1;
  		print("<P><B>Numro de ligne $ligne");
  		$erreur=1;
  		break;
	}

	$ip_int=ip2long($ip);
	if ( ( $ip_int >= $dyn_first_int ) && ( $ip_int <= $dyn_last_int ) )
	{
		print ("<P><font color=#FF0000>$ip </font>: rserve en ip dynamique ");
		$erreur=1;
		break;
	}
		
	/* tout est ok, on insre la ligne */	
  	$v_query=pg_exec($database,"insert into materiel values('$ip','$nom','$mac','$alias')");
  	if ( ! $v_query )
  	exit;
  	  $z++;
	}
	if ( $erreur )
	{
		print("<P>Traitement incorrect");
		$v_query=pg_exec($database,"rollback");
	}
	else
	{
		$v_query=pg_exec($database,"commit");
  		print("<P>Traitement termin");
  		print("<P>Nb de lignes traites : $z");
  	}
}

/* traite le fichier issu d'arpwatch */
/* pour insertion dans la table matriel */
/* au passage, les adresses ip sont formates : 192.168.173.1 devient 192.168.173.001 */
function traite_arp_tableau($tableau_origine,$database,$separ)
{
	/* rcuprer la plage dynamique si elle existe */
	global $dyn_first_int;
	global $dyn_last_int;

	plage_dynamique($database);	

	$faux_nom=1;
	$nb_lignes=count($tableau_origine);
	print("<BR>Nombre de lignes du fichier arpwatch : $nb_lignes");
	$tableau=nettoie_arp($tableau_origine);
	$nb_lignes=count($tableau);
		
	print ("<P>Nombre de lignes sans doublons : $nb_lignes");
  	
  	print ("<P>Traitement en cours ...");
  	
  	flush(); /* force l'affichage avant la fin de la page */
  	
	/* nettoyage de la table des adresses occupes */
	$v_query=pg_exec($database,"begin work");
	$v_query=pg_exec($database,"delete from materiel;");

	/* insertion des lignes du tableau */	
	$z=0;
	$v_insert=0;
	$erreur=0;  /* si erreur est vrai en sortie de boucle, annuler transaction */
	while ($z < $nb_lignes )
	{
	/* traitement de chaque ligne */
  		$warning=0;
  	
  	$tab_ligne=$tableau[$z];
  	$ip=$tab_ligne[1];
  	if ( ! valid_ip($ip) )
  		{
  		  print("<P><B>Erreur sur adresse ip : $tab_ligne[1] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}
  	
  	$ip=format_ip($ip);
  		if ( $ip == "" )
  		{
  		  print("<P><B>Erreur sur adresse ip : $tab_ligne[1] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}
  	/* vrifier si adresse ip prsente dans la plage du rseau  */
	$v_query=pg_exec($database,"select * from reseau where ip='$ip'");
	$v_count=pg_numrows($v_query);
	if ( $v_count == 0 )
	{       /* cettre adresse n'est pas dans notre plage */
		/* pas la peine de la traiter , on passe  la suivante*/
		$z++;
		continue;	
	}	
				

	
  	$nom=$tab_ligne[3];
  	if ( ! valid_name($nom) )
  		{
  		  print("<P><B>Erreur sur hostname : $nom </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	
  	$mac=$tab_ligne[0];
  	if ( ! valid_mac($mac) )
  		{
  		  print("<P><B>Erreur sur adresse mac : $tab_ligne[0] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	
  	$mac=format_mac($mac);
  		if ( $mac == "" )
  		{
  		  print("<P><B>Erreur sur adresse mac : $tab_ligne[0] </B>" );
  		  $ligne=$z+1;
  		  print("<P><B>Numro de ligne $ligne");
  		  $erreur=1;
  		  break;
  		}  	
  	$alias="";

  	/* vrifier doublons ventuels */
	$v_query=pg_exec($database,"select * from materiel where ip='$ip'");
	$v_count=pg_numrows($v_query);
	if ($v_count <> 0)
	{
		print("<H2> adresse ip $ip dja prise </H2>");
  		$ligne=$z+1;
  		print("<P><B>Numro de ligne $ligne");
  		$erreur=1;
  		break;
	}
	$v_query=pg_exec($database,"select * from materiel where mac='$mac'");
	$v_count=pg_numrows($v_query);
	if ($v_count <> 0)
	{
		print("<H2> adresse mac $mac dja prise pour adresse ip $ip</H2>");
  		$ligne=$z+1;
  		print("<P><B>A vrifier dans le fichier arpwatch<P>");
  		$warning=1;

	}

	$ip_int=ip2long($ip);
	if ( ( $ip_int >= $dyn_first_int ) && ( $ip_int <= $dyn_last_int ) )
	{
		print ("<P><font color=#FF0000>$ip </font>: rserve en ip dynamique ");
		$erreur=1;
		break;
	}

	/* ok pour insrer */
	/* dernire vrif sur le nom */
        if ( $nom == "" )
        {
                $nom="X".$faux_nom;
                $faux_nom++;
        }

	if ( ! $warning )
	{
		$v_query=pg_exec($database,"insert into materiel values('$ip','$nom','$mac','$alias')");
		if ( ! $v_query )
  			exit;
     		$v_insert++;
     	}
 	
 	$z++;
 	
	} /* suite du while fichier arp */
	
	
	if ( $erreur )
	{
		print("<P>Traitement incorrect");
		$v_query=pg_exec($database,"rollback");
	}
	else
	{
		$v_query=pg_exec($database,"commit");
  		print("<P>Traitement termin");
  		print("<P>Nb de lignes traites : $z");
  		print("<P>Nb d'adresses insres : $v_insert");	
  	}
}

function en_tete_tableau() /* en-tete du tableau de la fonction verif_arp_tableau */
{
	print ("<TABLE width=100% border=1>");
	print("<TR><TD BGCOLOR=#CCCCCC>Type erreur</TD>");
	print ("<TD colspan=2 align=center BGCOLOR=#CCCCCC>Adresse fichier ARP</TD>");
	print ("<TD colspan=2 align=center BGCOLOR=#CCCCCC>Adresse table matriel</TD></TR>");
	print("<TR><TD BGCOLOR=#CCCCCC>&nbsp;</TD><TD BGCOLOR=#CCCCCC>IP</TD><TD BGCOLOR=#CCCCCC>MAC</TD>");
	print ("<TD BGCOLOR=#CCCCCC>IP</TD><TD BGCOLOR=#CCCCCC>MAC</TD></TR>");
}

/* nettoyage tableau arpwatch pour suppression doublons */
/* on garde les lignes dont timestamp est le plus rcent */
/* en entre  : un tableau de chaines contenant les lignes du fichier arp.dat */
/* en sortie : un tableau  2 dimensions : n lignes, pour chaque ligne : mac ip timestamp nom */
function nettoie_arp($tableau)
{
$z=count($tableau);
$ind_2=0;

for ( $i=0 ; $i< $z; $i++ )
{
  	$tab_ligne=explode("\t",$tableau[$i]);

        /* chercher si ip dja prsente dans tableau2 */
        $nt2=count($tableau2);
        $j=0;
        $timestamp=0;
        while ( $j < $nt2 )
        {
        	if ( $tableau2[$j][1] == $tab_ligne[1] )
        	{
        		$old_timestamp=$tableau2[$j][2]; /* ip dja l : comparer le timestamp */
        		$new_timestamp=$tab_ligne[2];
        		if ( $old_timestamp < $new_timestamp )
        			/* remplacer ancienne valeur par nouvelle */
        			{        				
        				$timestamp= $new_timestamp;
        				$tableau2[$j][0]= $tab_ligne[0];
        				$tableau2[$j][1]= $tab_ligne[1];
        				$tableau2[$j][2]= $tab_ligne[2];
        				$tableau2[$j][3]= $tab_ligne[3];
        			}
        		else    /*  garder ancienne valeur */
        		{
        			$timestamp= $old_timestamp;
        		}
        			
        		$j=$nt2;		/* et quitter le while */
        	}
        	$j++;
        }
        if ( $timestamp == 0 ) /* c'est une nouvelle valeur  stocker */
	{
		$tableau2[$ind_2][0]=$tab_ligne[0];
		$tableau2[$ind_2][1]=$tab_ligne[1];
		$tableau2[$ind_2][2]=$tab_ligne[2];
		$tableau2[$ind_2][3]=$tab_ligne[3];
		$ind_2++;
	}
	
}
return($tableau2);
}

/* vrifie le fichier issu d'arpwatch */
/* pour affichage anomalies */
function verif_arp_tableau($tableau_origine,$database,$separ)
{
	$nb_lignes=count($tableau_origine);
	print("<BR>Nombre de lignes du fichier arpwatch : $nb_lignes");
	$tableau=nettoie_arp($tableau_origine);
	$nb_lignes=count($tableau);
		
	print ("<P>Nombre de lignes sans doublons : $nb_lignes");
  	
  	flush(); /* force l'affichage avant la fin de la page */
	
  	print ("<P>Traitement en cours ...");
  	
  	flush(); /* force l'affichage avant la fin de la page */
  	
  	print ("<P>");
  	
	/* les adresses lues dans le fichier arp */
	/* sont stockes dans la table arp */
	/* en fin de boucle, on pourra voir si toutes les adresses de notre table */
	/* materiel sont connues de arp */
	
	$v_query=pg_exec($database,"delete from arp;");

	
	/* vrification des  lignes du tableau */	
	$z=0;
	$warning=0;
	$err=0;
	while ($z < $nb_lignes )
	{
	
	/* dcoupage de chaque ligne  partir du sparateur | */
  	$tab_ligne=$tableau[$z];
  	$ip=$tab_ligne[1];
  	$ip=format_ip($ip);
  	/* vrifier si adresse ip prsente dans la plage du rseau  */
	$v_query=pg_exec($database,"select * from reseau where ip='$ip'");
	$v_count=pg_numrows($v_query);
	if ( $v_count == 0 )
	{       /* cettre adresse n'est pas dans notre plage */
		/* pas la peine de la traiter , on passe  la suivante*/
		$z++;
		continue;	
	}	
				

  	$nom=$tab_ligne[3];
  	$mac=$tab_ligne[0];
  	$mac=format_mac($mac);
  	$alias="";

	/* stocker l'adresse arp pour vrification finale */
	$v_query=pg_exec($database,"insert into arp values('$ip','$mac')");
	if ( ! $v_query )
  			exit;

  	/* vrification  sur la table matriel */
	$v_query=pg_exec($database,"select ip,mac from materiel where ip='$ip' and mac='$mac'");
	$v_count=pg_numrows($v_query);
	if ( $v_count==1)
	{       /* adresse correcte */
		/* on passe  la suivante*/
		$z++;
		continue;	
	}	
		
	$v_query=pg_exec($database,"select ip,mac from materiel where ip<>'$ip' and mac='$mac'");
	$v_count=pg_numrows($v_query);
	if ( $v_count<>O)
	{
		$row=pg_fetch_row($v_query,0);
		$table_ip=$row[0];
		$table_mac=$row[1];
		
		if ( $err == 0 && $warning ==0 )
				en_tete_tableau();

		/* erreur grave : ad ip diffrentes pour une mme adresse mac */
		print ("<TR><TD><font color=#FF0000><B>Erreur</B></FONT></TD>");
		print ("<TD><font color=#FF0000>$ip</i></FONT></TD><TD>$mac</TD><TD><font color=#FF0000><i>$table_ip</i></FONT></TD>");
		print ("<TD>$table_mac</TD></TR>");
		$err++;
		$z++;
		continue;
			
	}	
	
	$v_query=pg_exec($database,"select ip,mac from materiel where ip='$ip' and mac<>'$mac'");
	$v_count=pg_numrows($v_query);
	if ( $v_count<>O)
	{
		$row=pg_fetch_row($v_query,0);
		$table_ip=$row[0];
		$table_mac=$row[1];
		if ( $err == 0 && $warning ==0 )
				en_tete_tableau();
		         /* erreur grave : mac_adresses diffrentes pour une mme adresse ip */
		print ("<TR><TD><font color=#FF0000><B>Erreur</B></FONT></TD>");
		print ("<TD>$ip</TD><TD><font color=#FF0000><i>$mac</i></FONT></TD><TD>$ip</TD>");
		print ("<TD><font color=#FF0000><i>$table_mac</i></FONT></TD></TR>");
		$err++;
		$z++;
		continue;
	}
  	
	/* dernier cas : ni l'adresse ip ni l'adresse mac du fichier arp n'existent dans la table matriel */
		if ( $err == 0 && $warning ==0 )
				en_tete_tableau();
	print("<TR><TD><font color=#FFCC00><B>Anomalie</B></FONT></TD>");
	print ("<TD>$ip</TD><TD>$mac</TD><TD colspan=2 align=center><font color=#FFCC00><B>adresse inconnue</B></FONT></TD></TR>");
	$warning++;
	  	
  	$z++;
	} /* suite du while fichier arp */
	

	/* dernire vrification */
	/* les adresses de la table matrielles ont-elles toutes t vues par arpwatch ? */
	$v_query=pg_exec($database,"select ip,mac from materiel where ip not in (select ip from arp) ");
	$v_count=pg_numrows($v_query);
	if ( $v_count <> 0 )
	{
	  $z=0;
	  while ( $z <> $v_count )
	  {
	  	$row=pg_fetch_row($v_query,$z);
	  	$ip=$row[0];
	  	$mac=$row[1];
		if ( $err == 0 && $warning ==0 )
				en_tete_tableau();
		print ("<TR><TD><font color=#FFCC00><B>Anomalie</B></FONT></TD>");
		print ("<TD colspan=2 align=center><font color=#FFCC00><B>adresse inconnue</B></FONT></TD><TD>$ip</TD><TD>$mac</TD></TR>");
	  	$z++;
	  }
	}
	
	if ( $err == 0 && $warning ==0 )
		print("<BR><B>Aucune anomalie dtecte</B>");
	else
		print("</TABLE>");
	
	print("<P>Traitement termin");
  	
}

/*********  ifconfig ****************/
/* retourne une chaine correspondant  la ligne ifconfig contenant les infos : */
/*	adresse, mask, broadcast         */
/* d'abord sur eth1, pui sinon sur eth 0 */
/* si ni eth0 ni eth1; arrt sur erreur  */
function ifconfig()
{
	/* recherche d'abord sur eth1 */
	$eth="eth1";
	$sys = "/sbin/ifconfig eth1 2> /dev/null |grep Mas";
	unset($tab);
	$ifconfig = exec($sys,$tab,$retour);
	if ( count($tab) == 0 ) /* rien sur eth1, on prend eth0 */
	{
		$eth="eth0";
		$sys = "/sbin/ifconfig eth0 2> /dev/null  |grep Mas";
		/*********	pour test local ********************/
		/* $sys = "/bin/cat /tmp/angelus_ifconfig.txt |grep Mas"; */

		
		unset($tab);
		$ifconfig = exec($sys,$tab,$retour);
		if ( count($tab) == 0 )
		{
			print ("<H2>Aucune interface eth active");
			print ("<BR>Impossible d'aller plus loin</H2>");
			exit;
		}
	}
	print ("<H2>Interface $eth </H2>");
	return($ifconfig);
}	

/*  executer  chaque appel du fichier include */
require("/home/hadmin/html/config_pgsql.inc.php");

$ch_connect="host=localhost port=5432 dbname=$BASE_DHCP user=$ADMINUSER password=$ADMINPASS";

$database=@pg_connect($ch_connect);
if (  ! $database )
{
	print ("<H3>Erreur de connexion</H3>");
	print ("<H4>Prvenir l'administrateur systme</H4>");
	exit;
}

?>

