<?
/*  $Id: url_filters_config.inc.php,v 1.11 2004/01/09 15:57:26 bzizou Exp $

All those functions may be edited to connect the url filtering module on 
different kind of database system.

This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

SLIS : Serveur de communications Linux pour l'Internet Scolaire. 
Copyright (C) 1998-2003 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

require("pgsql.inc.php");
require("html.inc.php");
require("lib.inc.php");

$MAX_WAIT=90; 	// Max seconds to wait when applying

function init_db() 	// Init database server
{
  return dbconnect();
}

function close_db($db)	// Close database server
{
  pg_close($db);
}

function db_exec($db,$query) // Run a database query
{
  return pg_exec($db,$query);
}

function db_numrows($result) // Count the number of results
{
  return pg_numrows($result);
}

function db_result($result,$index,$col) // Returns a result
{
  return pg_result($result,$index,$col);
}

function networks($db)  // Returns the subnets in an array (nnn.nnn.nnn.nnn/mmm.mmm.mmm.mmm form)
{
  $query="select * from subnets order by id";
  $result = db_exec($db,$query);
  $count = db_numrows($result);
  for ($index=0; $index < $count; $index++) {
    $array[$index]=db_result($result,$index,"network")."/".db_result($result,$index,"netmask");
  }
  return $array;
}

function network_comment($db,$network) // Returns a comment corresponding to a network
                                       // This function may return an empty string
                                       // so that the behaviour will be disabled
{
  list($ip,$mask)=explode("/",$network);
  $query="select nom from subnets where network='$ip' and netmask='$mask'";
  $result = db_exec($db,$query);
  $count = db_numrows($result);
  if ($count) return db_result($result,0,"nom");
  else return "";
}


function groups($db) 	// Returns an array containing the system group names
{
  global $LDAP_SERVER,$LDAP_GROUPS;
  $ds=ldap_connect("$LDAP_SERVER");
  $r=ldap_bind($ds);
  $sr=ldap_search($ds,$LDAP_GROUPS, "cn=*");
  $info = ldap_get_entries($ds, $sr);
  for ($i=0; $i<$info["count"]; $i++) {
     $output[$i]=$info[$i]["cn"][0];
  }
  ldap_close($ds);
  return $output;
}
