<?php
/* $Id: url_filters.php,v 1.22 2004/01/20 17:07:50 bzizou Exp $

This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2003 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>

*/

// tools and libs
require("../inc/url_filters_config.inc.php");
require("../inc/url_filters.inc.php");

$to_apply=0;

// Connect to database
$db = init_db();

// Print something when an update is done so that the
// user see that something is done
if($updating) {
        $content  = $lang_Uf_updating."<br>\n";
        $content .= "<center><img src='../images/play_anim.gif' border='0'></center>\n";
        $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$content,$border,$lang_Uf_title,$titre_color,0);
        $val = center($val);
        $val = saut(2)."$val";

        echo "<html>\n";
        echo "<head>\n";
        echo "<base target='_top'>\n";
        $base_name=urlencode($base_name);
        echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?action=$action&rule=$rule&base=$base&base_name=$base_name&string=$string'\">\n";
        echo "</head>\n";
        echo "<font FACE='Helvetica,Arial'>\n";
        echo "$val\n";
        echo "</body>\n";
        echo "</html>\n";
        return;
}


switch($action) {

// Apply changes
case 'apply' :
  $content=startHTML("$lang_Uf_title");
  $err=apply();
  sleep(1);
  if ($err) {
    $content.="<BR><CENTER><I>$lang_Uf_timeout</I></CENTER><P>\n";
  }
  else {
    $content.="<BR><CENTER><I>$lang_Uf_done</I></CENTER><P>\n";
  }
  $content.=links();
  $content.=endHTML();
  $title=$lang_Uf_title;
  break;

// Edit a rule
case 'edit_rule' :
  $content=startHTML("$lang_Uf_title");
  if ($just_edited) {
    $content.="<P><CENTER><I>$lang_Valid_for_active_changes</I></CENTER><P>\n";
  }
  $content.=edit_rule($rule);
  $content.="<P><HR WIDTH=100%>\n";
  $content.=links();
  $content.=endHTML();
  $title=$lang_Uf_edit_rule;
  break;

// Action for a rule edition
case 'edit' :
  $to_apply=1;
  $err=edit($name,$network,$group,$rule);
  if ($err) {
      $title=$lang_Uf_edit_rule;
      $content=startHTML("$lang_Uf_title");
      $content.="<P>\n";
      switch($err) {
      case '1' :
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_nameempty</FONT>";
        break;
      case '2' :
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_sourcealready</FONT>";
        break;
      case '3' :
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_defalready</FONT>";
        break;
      default :
        $content.="<FONT COLOR=FF0000>Unknown error number $err!</FONT>";
        break;
      }
      $content.="<P><CENTER><A HREF=\"javascript:history.back();\">&lt;&lt;</A></CENTER>\n";
      $content.=endHTML();
  }
  else {
    header("Location: url_filters.php?action=edit_rule&rule=$rule&updating=1");
  }
  break;

// Add a new rule and open edition window
case 'add_rule' :
  $id=add_rule($name,$network,$group,$err);
  $to_apply=1;
  if ($id) {
    header("Location: url_filters.php?action=edit_rule&rule=$id");
  }
  else {
    $title=$lang_Uf_edit_rule;
    $content=startHTML("$lang_Uf_title");
    $content.="<P>\n";
    switch($err) {
      case '1' : 
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_nameempty</FONT>";
        break;
      case '2' :
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_sourcealready</FONT>";
        break;
      case '3' :
        $content.="<FONT COLOR=FF0000>$lang_Uf_err_defalready</FONT>";
        break;
      default :
        $content.="<FONT COLOR=FF0000>Unknown error number $err!</FONT>";
        break;
    }
    $content.="<P><CENTER><A HREF=\"javascript:history.back();\">&lt;&lt;</A></CENTER>\n";
    $content.=endHTML();
  }
  break;

// Add a base to a rule
case 'add_baselist' :
  add_baselist($rule,$type,$base);
  $to_apply=1;
  header("Location: url_filters.php?action=edit_rule&rule=$rule");
  break;

// Delete a base from a rule
case 'del_baselist' :
  del_baselist($base);
  $to_apply=1;
  header("Location: url_filters.php?action=edit_rule&rule=$rule");
  break;

// Swap 2 bases into a rule
case 'swap_baselist' :
  swap_baselist($id1,$id2);
  $to_apply=1;
  header("Location: url_filters.php?action=edit_rule&rule=$rule");
  break;


// Delete a rule
case 'del_rule' :
  if ($sure) {
    delete_rule($rule);
    $to_apply=1;
    header("Location: url_filters.php");
  }
  else {
    $link_ok="url_filters.php?action=del_rule&rule=$rule&sure=1";
    $link_cancel="url_filters.php";
    $content=startHTML("$lang_Uf_title");
    $content.=are_you_sure($lang_Uf_suredelrule,$link_ok,$link_cancel,$name);
    $content.=endHTML();
    $title=$lang_Uf_rules;
  }
  break;

// Swap 2 rules
case 'swap_rules' :
  swap_rules($id1,$id2);
  $to_apply=1;
  header("Location: url_filters.php"); 
  break;

// Edit the name of a rule
case 'edit_rule_name' :
  $content=startHTML("$lang_Uf_edit_rule");
  edit_rule_name($rule,$string);
  $content.=edit_rule($rule);
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_edit_rule";
  break;

// Edit a custom base
case 'edit_base' :
  $content=startHTML("$lang_Uf_titlebases");
  $content.=edit_base($base);
  if (!$base) { $to_apply=1; };
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_titlebases: \"$base_name\" edition";
  break;

// Delete a custom base
case 'del_base' :
  if ($sure) {
    del_base($base);
    $to_apply=1;
    header("Location: url_filters.php?action=list_bases");
  }
  else {
    $link_ok="url_filters.php?action=del_base&base=$base&sure=1";
    $link_cancel="url_filters.php?action=list_bases";
    $content=startHTML("$lang_Uf_title");
    $content.=are_you_sure($lang_Uf_suredelbase,$link_ok,$link_cancel,$base_name);
    $content.=endHTML();
    $title=$lang_Uf_titlebases;
  }
  break;

// Add an item into a custom base
case 'add_base_item' :
  $content=startHTML("$lang_Uf_titlebases");
  $to_apply=1;
  add_base_item($base,$item,$string);
  $content.=edit_base($base);
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_titlebases: \"$base_name\" edition";
  break;

// Del an item from a custom base
case 'del_base_item' :
  $content=startHTML("$lang_Uf_titlebases");
  $to_apply=1;
  del_base_item($base,$item,$id);
  $content.=edit_base($base);
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_titlebases: \"$base_name\" edition";
  break;

// Edit the name of a custom base
case 'edit_base_name' :
  $content=startHTML("$lang_Uf_titlebases");
  edit_base_name($base,$string);
  $content.=edit_base($base);
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_titlebases: \"$string\" edition";
  break;


// Edit the comment of a custom base
case 'edit_base_comment' :
  $content=startHTML("$lang_Uf_titlebases");
  edit_base_comment($base,$string);
  $content.=edit_base($base);
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title="$lang_Uf_titlebases: \"$base_name\" edition";
  break;


// List the custom bases
case 'list_bases' :
  $content=startHTML("$lang_Uf_titlebases");
  $content.=list_bases();
  $content.="<P><HR WIDTH=100%>";
  $content.=links();
  $content.=endHTML();
  $title=$lang_Uf_titlebases;
  break;

case 'auto_blacklist' :
  $content=startHTML("$lang_Uf_title");
  if ($sure) {
    $content.=edit_rule(auto_blacklist());
    $to_apply=1;
    touch("$QUEUE/to_apply.url_filters");
    $content.="<P><HR WIDTH=100%>\n";
    $content.=links();
    $content.=endHTML();
    $title=$lang_Uf_edit_rule;
  }
  else {
    $link_ok="url_filters.php?action=auto_blacklist&sure=1";
    $link_cancel="url_filters.php?action=index";
    $content=startHTML("$lang_Uf_title");
    $content.=are_you_sure($lang_Uf_auto_blacklist,$link_ok,$link_cancel,0);
    $content.=endHTML();
    $title=$lang_Uf_title;
  }
  break;

// Index
case 'index' :
  $content=startHTML("$lang_Uf_title");
  $content.="<UL>\n";
  $content.="<LI><A HREF=?action=auto_blacklist>$lang_Uf_index_auto</A>\n";
  $content.="<LI><A HREF=?action=list_rules>$lang_Uf_index_rules</A>\n";
  $content.="<LI><A HREF=?action=list_bases>$lang_Uf_index_bases</A></UL>\n";
  $content.=endHTML();
  $title=$lang_Uf_title;
  break;

// Default: list the rules
default:
  $content=startHTML("$lang_Uf_title");
  $content.=list_rules();
  $content.="<P><HR>";
  $content.=links();
  $content.=endHTML();
  $title=$lang_Uf_rules;
  break;
}

// Touch a tag if something has to be validated
if ($to_apply) {
  touch("$QUEUE/to_apply.url_filters");
}

// Outputs
$val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$content,$border,$title,$titre_color,0);
$val = center($val);
$val = saut(2)."$val";
print "$val\n";

// Close database connection
close_db($db);
                  
?>
