#!/bin/bash
# $Id: slis-sys.inc.bash,v 1.2 2003/12/04 14:57:44 bzizou Exp $ #
#
# Bash include for SLIS system subroutines
#
# This script is part of the SLIS Project initiated by the CARMI-Internet
# (Acadmie de Grenoble - France 38).
# Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
# (Acadmie de Grenoble - France 38).
#
# SLIS : Serveur de communications Linux Pour l'Internet Scolaire.
# Copyright (C) 1998-2003 Bruno Bzeznik
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    You should have received a copy of the GNU General Public License
#    along with this program (For example ./COPYING);
#    if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
#    Cambridge, MA 02139, USA.
#
# Please send all comments and bug reports by electronic mail to:
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# or to <slis@ac-grenoble.fr>
#
# Envoyez vos suggestions et reports de bugs par e-mail 
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# ou  <slis@ac-grenoble.fr>
#

# load_config
# It loads the SLIS variables
function load_config {
  if [ -f /etc/slis/slis.conf ]
  then
    . /etc/slis/slis.conf
  else
    /usr/bin/logger -t "slis-sys.inc.bash" "Warning: /etc/slis/slis.conf not found, loading old files /home/hadmin.setup.data"
    . /home/hadmin/setup.data
  fi
  
  # Old variables for compat
  INTERNET_NET=$NETWORK0;
  INTERNET_IP=$IPADDR0;
  INTERNET_MASK=$NETMASK0;
  INTRANET_NET=$NETWORK1;
  INTRANET_IP=$IPADDR1;
  INTRANET_MASK=$NETMASK1;
  IPADDR=$IPADDR1;
}
    
# error
# Prints and log an error
function error {
  echo "$2"
  /usr/bin/logger -t "$1" "$2"
} 
