#!/bin/bash

. /usr/local/lib/slis-sys.inc.bash
load_config

if [ -s /etc/samba/machine_next_uid ]
then
  declare -i NEXT_UID=`cat /etc/samba/machine_next_uid`
  expr $NEXT_UID + 1 > /etc/samba/machine_next_uid
else
 NEXT_UID=10000
 echo 10001 > /etc/samba/machine_next_uid
fi

RID=`expr $NEXT_UID \* 2 + 1000`

cat << EOF | ldapadd -x -D "$LDAP_ROOT_DN" -w `cat /etc/openldap/secret`
dn: uid=$1\$,$LDAP_COMPS
objectClass: sambaAccount
uid: $1\$
rid: $RID
EOF

smbpasswd  -m -a "$1\$"

sleep 1
