#!/bin/bash
# $Id: init_pgsql.sh,v 3.1 2003/09/22 09:54:58 bzizou Exp $

# fichier config postgres :
CONF=/var/lib/pgsql/data/pg_hba.conf  

# mot de passe postgres
POSTGRESPASS=$1

# mot de passe hadmin
ADMINPASS=$2

# mot de passe slis
SLISPASS=$3

# fichier cration base dhcp
DHCP=/tmp/dhcp.dump

# au dpart les droits de pg_hba.conf sont sur trust
# dans le doute : mettre les droits sur trust et localhost only

echo "local all all trust" > $CONF
chmod u-w $CONF
chown postgres $CONF
/etc/rc.d/init.d/postgresql restart > /dev/null

export PGUSER=postgres
export PGPASSWORD=$POSTGRESPASS

psql template1 -tqc "alter user postgres with password '$POSTGRESPASS' "
sleep 5

# remettre les droits sur password
echo "local all all password"  > $CONF
echo "host all all 127.0.0.1 255.255.255.255 password" >> $CONF
chmod u-w $CONF
chown postgres $CONF
/etc/rc.d/init.d/postgresql restart > /dev/null

# Creation des users et des bases
psql template1 -f - >/dev/null 2>/tmp/psql.err <<EOF 
drop user hadmin;
create user hadmin with password '$ADMINPASS' nocreatedb nocreateuser;
drop user slis;
create user slis with password '$SLISPASS' createdb nocreateuser;
drop database dhcp;
drop database hadmin;
drop database slis;
create database dhcp;
create database hadmin;
create database slis;
EOF

# Affichage eventuel des erreurs
grep -i error /tmp/psql.err |grep -v DROP

# cration tables dhcp
psql  dhcp < $DHCP >/dev/null
