#!/bin/bash
# $Id: init_smbldap.bash,v 1.2 2004/02/09 20:59:09 bzizou Exp $
# Inits the ldapconfiguration for samba

. /usr/local/lib/slis-sys.inc.bash
load_config

SAMBACN="samba"

# Creates the samba's ldap manager account
PASS=`$SLIS_BINDIR/pspg`
CRYPTED_PASS=`/usr/sbin/slappasswd -h {MD5} -s $PASS`
cat << EOF | ldapadd -x -D "$LDAP_ROOT_DN" -w `cat /etc/openldap/secret`
dn: cn=$SAMBACN, $LDAP_USERS
objectClass: shadowAccount
objectClass: top
uid: $SAMBACN
userPassword: $CRYPTED_PASS
shadowLastChange: 12451
shadowMin: -1
shadowMax: 99999
shadowWarning: 7
shadowInactive: -1
shadowExpire: -1
shadowFlag: 134538308
description: Samba manager access
EOF

# Gives the samba manager password
smbpasswd -w $PASS

# Creates the smb root acount (login:root, passwd:slis)
cat << EOF | ldapadd -x -D "$LDAP_ROOT_DN" -w `cat /etc/openldap/secret`
dn: uid=root, $LDAP_USERS
objectClass: sambaAccount
objectClass: top
uid: root
rid: 1000
cn: root
lmPassword: 2D9DEDB375B894F4AAD3B435B51404EE
ntPassword: E934D77D6FD96BF8A87B7AF7B8C9F462
pwdLastSet: 1044468320
logonTime: 0
logoffTime: 2147483647
kickoffTime: 2147483647
pwdCanChange: 0
pwdMustChange: 2147483647
acctFlags: [UX         ]
displayName: root
primaryGroupID: 1001
EOF


