/*   $Id: hadmin.sql,v 1.8 2003/12/22 18:08:03 bzizou Exp $ */ 
/*   SLIS SQL structure for database "hadmin" */

CREATE SEQUENCE "common_id" start 100 increment 1 maxvalue 2147483647 minvalue 100 cache 1;


CREATE SEQUENCE "cyber_ecole_id" start 1 increment 1 maxvalue 99 minvalue 1 cache 1;


CREATE TABLE "alias" (
	"id" integer NOT NULL,
	"alias" character varying(30) NOT NULL,
	"modif" boolean,
	"nouveau" boolean,
	"delete" boolean,
	"tovalid" boolean,
	Constraint "alias_pkey" Primary Key ("alias")
);



CREATE TABLE "classes" (
	"id" integer DEFAULT nextval('common_id'::text) NOT NULL,
	"nom" character varying(30) NOT NULL,
	"modif" boolean,
	"nouveau" boolean,
	"delete" boolean,
	"tovalid" boolean,
	Constraint "classes_pkey" Primary Key ("id")
);



CREATE TABLE "groups" (
	"userid" integer NOT NULL,
	"classeid" integer NOT NULL,
	"modif" boolean,
	"nouveau" boolean,
	"delete" boolean,
	"tovalid" boolean,
	"primary" boolean
);



CREATE TABLE "users" (
	"id" integer DEFAULT nextval('common_id'::text) NOT NULL,
	"nom" character varying(30) NOT NULL,
	"prenom" character varying(30) NOT NULL,
	"code" character varying(32),
	"infos" character varying(60),
	"login" character varying(32) NOT NULL,
	"passwd" character varying(8) NOT NULL,
	"modif" boolean,
	"nouveau" boolean,
	"delete" boolean,
	"tovalid" boolean,
	Constraint "users_pkey" Primary Key ("id")
);



CREATE TABLE "oldvalue" (
	"id" integer NOT NULL,
	"nom" character varying(30) NOT NULL,
	"prenom" character varying(30),
	"infos" character(60),
	"login" character varying(32),
	"passwd" character varying(35),
	"code" character varying(32),
	Constraint "oldvalue_pkey" Primary Key ("id")
);



CREATE TABLE "badlogin" (
	"nom" character varying(30) NOT NULL,
	Constraint "badlogin_pkey" Primary Key ("nom")
);



CREATE TABLE "password" (
	"id" integer NOT NULL,
	"md5" character varying(35) NOT NULL,
	"crypt" character varying(35) NOT NULL,
	Constraint "password_pkey" Primary Key ("id")
);



CREATE TABLE "security_filters" (
	"filter" integer NOT NULL,
	"type" character varying(8) NOT NULL,
	"rule" character varying(8) NOT NULL,
	"predefined" boolean NOT NULL,
	"predefined_string" character varying(8),
	"protocol" character varying(4),
	"src" character varying(15),
	"src_mask" character varying(15),
	"src_port" smallint,
	"dst" character varying(15),
	"dst_mask" character varying(15),
	"dst_port" smallint,
	Constraint "security_filters_pkey" Primary Key ("filter")
);


CREATE TABLE "options" (
	"name" character varying(32) NOT NULL,
	"value" character varying(32),
	"tovalid" boolean NOT NULL,
	"old_value" character varying(32)
);


CREATE SEQUENCE "subnet_id" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;


CREATE SEQUENCE "bar_id" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;


CREATE TABLE "subnets" (
	"id" integer DEFAULT nextval('subnet_id'::text) NOT NULL,
	"nom" character varying(30) NOT NULL,
	"network" character varying(15) NOT NULL,
	"netmask" character varying(15) NOT NULL,
	"status" boolean,
	"type" smallint,
	Constraint "subnets_pkey" Primary Key ("id")
);


CREATE TABLE "subnetstat" (
	"id" integer DEFAULT nextval('bar_id'::text) NOT NULL,
	"subid" integer NOT NULL,
	"actif" integer NOT NULL,
	"inactif" integer NOT NULL,
	"days" integer NOT NULL,
	Constraint "subnetstat_pkey" Primary Key ("id")
);


CREATE TABLE "conns" (
	"start" timestamp with time zone NOT NULL,
	"stop" timestamp with time zone,
	"time" integer
);


CREATE SEQUENCE "mail_filter_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;


CREATE TABLE "mail_filter" (
	"val_opt" character varying(20) NOT NULL,
	"rule" character varying(255) NOT NULL
);


CREATE TABLE "mail_filter_regex" (
	"val_opt" character varying(30) NOT NULL,
	"regex_rule" text NOT NULL
);


CREATE SEQUENCE "options_users_id_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;


CREATE TABLE "options_users" (
	"id" integer DEFAULT nextval('"options_users_id_seq"'::text) NOT NULL,
	"userid" integer NOT NULL,
	"type_opt" character varying(30) NOT NULL,
	"val_opt" character varying(30) NOT NULL,
	"modif" boolean DEFAULT 'f'::bool,
	"nouveau" boolean DEFAULT 'f'::bool,
	"delete" boolean DEFAULT 'f'::bool,
	"tovalid" boolean DEFAULT 'f'::bool
);


CREATE TABLE "dnsmachine" (
	"ip" character varying(32) NOT NULL,
	"nom" character varying(128) NOT NULL,
	"zone" integer DEFAULT 1,
	"alias" character varying(128),
	"commentaire" character varying(255),
	"tovalid" boolean DEFAULT '1',
	"tomodif" boolean DEFAULT '0',
	"todelete" boolean DEFAULT '0',
	"nip" character varying(32),
	"nnom" character varying(128),
	"nalias" character varying(128),
	"ncommentaire" character varying(255)
);


CREATE TABLE "dnszone" (
	"idzone" integer,
	"nomzone" character varying(128),
	"nnomzone" character varying(128)
);


CREATE TABLE "access_apache" (
	"time" timestamp with time zone,
	"host" character varying(32),
	"user" character varying(32),
	"request" character varying(255),
	"status" integer,
	"bytes" integer
);


CREATE TABLE "access_squid" (
	"time" timestamp with time zone,
	"elapsed" integer,
	"remotehost" character varying(32),
	"code_status" character varying(32),
	"bytes" integer,
	"method" character varying(16),
	"url" character varying(255),
	"peerstatus" character varying(128),
	"user" character varying(32)
);


CREATE INDEX alias_alias_key ON alias USING btree (alias);


CREATE INDEX id_classes_key ON classes USING btree (id);


CREATE INDEX nom_classes_key ON classes USING btree (nom);


CREATE INDEX userid_groups_key ON groups USING btree (userid);


CREATE INDEX classeid_groups_key ON groups USING btree (classeid);


CREATE INDEX primary_groups_key ON groups USING btree (userid);


CREATE UNIQUE INDEX users_login_key ON users USING btree (login);


CREATE INDEX id_users_key ON users USING btree (id);


CREATE INDEX nom_users_key ON users USING btree (nom);


CREATE INDEX login_users_key ON users USING btree (login);


CREATE INDEX modif_users_key ON users USING btree (modif);


CREATE INDEX nouveau_users_key ON users USING btree (nouveau);


CREATE INDEX code_users_ukey ON users USING btree (code);


CREATE INDEX id_oldvalue_key ON oldvalue USING btree (id);


CREATE INDEX nom_badlogin_key ON badlogin USING btree (nom);


CREATE INDEX id_password_key ON "password" USING btree (id);


CREATE INDEX filter_security_filters_key ON security_filters USING btree (filter);


CREATE INDEX type_security_filters_key ON security_filters USING btree ("type");


CREATE INDEX predefined_security_filters_key ON security_filters USING btree (predefined);


CREATE UNIQUE INDEX name_options_ukey ON options USING btree (name);


CREATE INDEX id_subnets_key ON subnets USING btree (id);


CREATE INDEX nom_subnets_key ON subnets USING btree (nom);


CREATE INDEX status_subnets_key ON subnets USING btree (status);


CREATE INDEX type_subnets_key ON subnets USING btree ("type");


CREATE INDEX id_subnetstat_key ON subnetstat USING btree (id);


CREATE INDEX subid_subnetstat_key ON subnetstat USING btree (subid);


CREATE INDEX days_subnetstat_key ON subnetstat USING btree (days);


CREATE INDEX mail_filter_val_opt_key ON mail_filter USING btree (val_opt);


CREATE INDEX val_opt_mail_filter_regex_key ON mail_filter_regex USING btree (val_opt);


CREATE INDEX modif_options_users_key ON options_users USING btree (modif);


CREATE INDEX nouveau_options_users_key ON options_users USING btree (nouveau);


CREATE INDEX type_opt_options_users_key ON options_users USING btree (type_opt);


CREATE INDEX userid_options_users_key ON options_users USING btree (userid);


CREATE INDEX time_access_apache_key ON access_apache USING btree ("time");


CREATE INDEX time_access_squid_key ON access_squid USING btree ("time");

/* Default bad logins */
INSERT INTO "badlogin" ("nom") VALUES('root');
INSERT INTO "badlogin" ("nom") VALUES('bin');
INSERT INTO "badlogin" ("nom") VALUES('sys');
INSERT INTO "badlogin" ("nom") VALUES('pgsql');
INSERT INTO "badlogin" ("nom") VALUES('apache');
INSERT INTO "badlogin" ("nom") VALUES('mail');
INSERT INTO "badlogin" ("nom") VALUES('nobody');
INSERT INTO "badlogin" ("nom") VALUES('daemon');
INSERT INTO "badlogin" ("nom") VALUES('adm');
INSERT INTO "badlogin" ("nom") VALUES('lp');
INSERT INTO "badlogin" ("nom") VALUES('sync');
INSERT INTO "badlogin" ("nom") VALUES('shutdown');
INSERT INTO "badlogin" ("nom") VALUES('halt');
INSERT INTO "badlogin" ("nom") VALUES('news');
INSERT INTO "badlogin" ("nom") VALUES('uucp');
INSERT INTO "badlogin" ("nom") VALUES('operator');
INSERT INTO "badlogin" ("nom") VALUES('games');
INSERT INTO "badlogin" ("nom") VALUES('gopher');
INSERT INTO "badlogin" ("nom") VALUES('ftp');
INSERT INTO "badlogin" ("nom") VALUES('ntp');
INSERT INTO "badlogin" ("nom") VALUES('vcsa');
INSERT INTO "badlogin" ("nom") VALUES('ldap');
INSERT INTO "badlogin" ("nom") VALUES('mailnull');
INSERT INTO "badlogin" ("nom") VALUES('rpm');
INSERT INTO "badlogin" ("nom") VALUES('pcap');
INSERT INTO "badlogin" ("nom") VALUES('named');
INSERT INTO "badlogin" ("nom") VALUES('ident');
INSERT INTO "badlogin" ("nom") VALUES('postgres');
INSERT INTO "badlogin" ("nom") VALUES('squid');
INSERT INTO "badlogin" ("nom") VALUES('nscd');
INSERT INTO "badlogin" ("nom") VALUES('smmsp');
INSERT INTO "badlogin" ("nom") VALUES('hadmin');
INSERT INTO "badlogin" ("nom") VALUES('http');

/* Default mail filters */
INSERT INTO "mail_filter" ("val_opt", "rule") VALUES('extranet', '*');
INSERT INTO "mail_filter" ("val_opt", "rule") VALUES('intranet', '---');
INSERT INTO "mail_filter_regex" ("val_opt", "regex_rule") VALUES('extranet', '^<?.*>?$');
INSERT INTO "mail_filter_regex" ("val_opt", "regex_rule") VALUES('intranet', '^<?--->?$');

/*
 * $Id: hadmin.sql,v 1.8 2003/12/22 18:08:03 bzizou Exp $
 * URL FILTER MODULE
 * SLIS project
 * This file is part of the SLIS Project initiated by the 
 * CARMI-Internet (Acadmie de Grenoble - France 38).
 *
 * Bruno@ac-grenoble.fr - (C)2003
 */

CREATE SEQUENCE "uf_rule_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_baselist_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_base_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_url_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_domain_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_expression_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;

CREATE TABLE "uf_rule" (
   "id" int4 DEFAULT nextval('"uf_rule_id_seq"'::text) NOT NULL,
   "name" varchar(128) NOT NULL,
   "network" varchar(128),
   "group" varchar(128)
);
CREATE  INDEX "uf_rule_id_key" ON "uf_rule" ("id");

CREATE TABLE "uf_baselist" (
   "id" int4 DEFAULT nextval('"uf_baselist_id_seq"'::text) NOT NULL,
   "type" varchar(128) NOT NULL,
   "rule" int4 NOT NULL,
   "base" int4 NOT NULL
);
CREATE  INDEX "uf_baselist_id_key" ON "uf_baselist" ("id");

CREATE TABLE "uf_base" (
   "id" int4 DEFAULT nextval('"uf_base_id_seq"'::text) NOT NULL,
   "name" varchar(128) NOT NULL,
   "type" varchar(32) NOT NULL,
   "comment" text
);
CREATE  INDEX "uf_base_id_key" ON "uf_base" ("id");

CREATE TABLE "uf_url" (
   "id" int4 DEFAULT nextval('"uf_url_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "url" text
);

CREATE TABLE "uf_domain" (
   "id" int4 DEFAULT nextval('"uf_domain_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "domain" text
);

CREATE TABLE "uf_expression" (
   "id" int4 DEFAULT nextval('"uf_expression_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "expression" text
);

INSERT INTO "uf_rule" ("name") VALUES('default');
INSERT INTO "uf_base" ("name","type","comment") VALUES('adult','predef','Sites a caractere pornographique');
INSERT INTO "uf_base" ("name","type","comment") VALUES('forums','predef','Forums');
INSERT INTO "uf_base" ("name","type","comment") VALUES('publicite','predef','Banieres de publicite');
INSERT INTO "uf_base" ("name","type","comment") VALUES('warez','predef','Sites de piratage');
INSERT INTO "uf_base" ("name","type","comment") VALUES('academie','predef','Base academique');
INSERT INTO "uf_base" ("name","type","comment") VALUES('in-addr','predef','Adresses ip');
INSERT INTO "uf_base" ("name","type","comment") VALUES('all','predef','Tout internet');
INSERT INTO "uf_baselist" ("type","rule","base") VALUES('block','1','3');
INSERT INTO "uf_baselist" ("type","rule","base") VALUES('pass','1','7');

