-- $Horde: horde/scripts/db/auth.sql,v 1.5.2.2 2002/04/18 22:12:25 jan Exp $

CREATE TABLE horde_users (
    user_uid       varchar(255) not null,
    user_pass      varchar(32) not null,
    primary key (user_uid)
);

GRANT SELECT, INSERT, UPDATE, DELETE ON horde_users TO hordemgr;
-- $Horde: horde/scripts/db/prefs.sql,v 1.3.2.3 2002/03/11 19:31:36 chuck Exp $

create table horde_prefs (
    pref_uid        char(255) not null,
    pref_scope      char(16) not null default '',
    pref_name       char(32) not null,
    pref_value      text,
    primary key (pref_uid, pref_scope, pref_name)
);

grant select, insert, update, delete on horde_prefs to hordemgr;
-- $Horde: horde/scripts/db/category.sql,v 1.2.2.9 2002/08/23 00:30:11 jan Exp $

CREATE TABLE horde_categories (
       category_id INT NOT NULL,
       group_uid VARCHAR(255) NOT NULL,
       user_uid VARCHAR(255) NOT NULL,
       category_name VARCHAR(255) NOT NULL,
       category_parents VARCHAR(255) NOT NULL,
-- There is no portable way to do this apparently. If your db doesn't allow varchars
-- greater than 255 characters, then maybe it allows TEXT columns, so try the second
-- line.
       category_data VARCHAR(2048),
--     category_data TEXT,
       category_serialized SMALLINT DEFAULT 0 NOT NULL,
       category_updated TIMESTAMP,
       PRIMARY KEY (category_id)
);

CREATE INDEX category_category_name_idx ON horde_categories (category_name);
CREATE INDEX category_group_idx ON horde_categories (group_uid);
CREATE INDEX category_user_idx ON horde_categories (user_uid);
CREATE INDEX category_serialized_idx ON horde_categories (category_serialized);

GRANT SELECT, INSERT, UPDATE, DELETE ON horde_categories TO hordemgr;
