/*
 * SLIS project
 * This file is part of the SLIS Project initiated by the 
 * CARMI-Internet (Acadmie de Grenoble - France 38).
 *
 * MAIL FILTER MODULE
 * Contact : Olivier.LeCam@crdp.ac-versailles.fr
 */

CREATE SEQUENCE "mail_filter_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "options_users_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;

/* --------------------------------------------------------
  Table structure for table "mail_filter"
-------------------------------------------------------- */
CREATE TABLE "mail_filter" (
   "val_opt" varchar(20) NOT NULL,
   "rule" varchar(255) NOT NULL
);
CREATE  INDEX "mail_filter_val_opt_key" ON "mail_filter" ("val_opt");
INSERT INTO "mail_filter" ("val_opt", "rule") VALUES('extranet', '*');
INSERT INTO "mail_filter" ("val_opt", "rule") VALUES('intranet', '---');

/* --------------------------------------------------------
  Table structure for table "mail_filter_regex"
-------------------------------------------------------- */
CREATE TABLE "mail_filter_regex" (
   "val_opt" varchar(30) NOT NULL,
   "regex_rule" text NOT NULL,
);
CREATE  INDEX "val_opt_mail_filter_regex_key" ON "mail_filter_regex" ("val_opt");
INSERT INTO "mail_filter_regex" ("val_opt", "regex_rule") VALUES('extranet', '^<?.*>?$');
INSERT INTO "mail_filter_regex" ("val_opt", "regex_rule") VALUES('intranet', '^<?--->?$');

/* --------------------------------------------------------
  Table structure for table "options_users"
-------------------------------------------------------- */
CREATE TABLE "options_users" (
   "id" int4 DEFAULT nextval('"options_users_id_seq"'::text) NOT NULL,
   "userid" int4 NOT NULL,
   "type_opt" varchar(30) NOT NULL,
   "val_opt" varchar(30) NOT NULL,
   "modif" bool DEFAULT 'f'::bool,
   "nouveau" bool DEFAULT 'f'::bool,
   "delete" bool DEFAULT 'f'::bool,
   "tovalid" bool DEFAULT 'f'::bool
);
CREATE  INDEX "modif_options_users_key" ON "options_users" ("modif");
CREATE  INDEX "nouveau_options_users_key" ON "options_users" ("nouveau");
CREATE  INDEX "type_opt_options_users_key" ON "options_users" ("type_opt");
CREATE  INDEX "userid_options_users_key" ON "options_users" ("userid");

/* RIGHTS */
GRANT ALL on "mail_filter" TO hadmin;
GRANT ALL on "mail_filter_regex" TO hadmin;
GRANT ALL on "options_users" TO hadmin;
