CREATE SEQUENCE "squidpersoid" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
CREATE SEQUENCE "squidaccessid" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;
/* --------------------------------------------------------
  Table structure for table "squidstatus"
-------------------------------------------------------- */

CREATE TABLE "squidstatus" (
"id" int2 NOT NULL,
"nom" varchar (30) NOT NULL,
"actif" bool NOT NULL,
"tovalid" bool NOT NULL,
"desc" varchar(100),
PRIMARY KEY ("id"), UNIQUE ("id"));
CREATE INDEX "squidstatus_actif_key" ON "squidstatus"("actif");
CREATE INDEX "squidstatus_tovalid_key" ON "squidstatus"("tovalid");

GRANT ALL on squidstatus to hadmin;

/* --------------------------------------------------------
  Table structure for table "squidperso"
-------------------------------------------------------- */
CREATE TABLE "squidperso" (
   "id" int4 DEFAULT nextval('squidpersoid'::text) NOT NULL,
   "domaine" varchar(50),
   "url" varchar(100),
   "exp" varchar(50),
   UNIQUE ("domaine"),
   UNIQUE ("exp"),
   UNIQUE ("url"),
   PRIMARY KEY ("id")
);

GRANT ALL on squidperso to hadmin;
/* --------------------------------------------------------
  Table structure for table "squidaccess"
-------------------------------------------------------- */
CREATE TABLE "squidaccess" (
   "id" int4 DEFAULT nextval('squidaccessid'::text) NOT NULL,
   "domaine" varchar(50),
   "url" varchar(100),
   "exp" varchar(50),
   UNIQUE ("domaine"),
   UNIQUE ("exp"),
   UNIQUE ("url"),
   PRIMARY KEY ("id")
);
GRANT ALL on squidaccess to hadmin;

/* -------------------------------------------------------- 
  Dumping data for table "squidstatus" 
-------------------------------------------------------- */ 
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(1, 'TOUT', 't', 't', 'Tout l\'internet, sauf les sites dfinis dans la base AUTORISES');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(3, 'PIRATAGE', 't', 't', 'Piratage de logiciels commerciaux - Warez');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(4, 'FORUMS', 't', 't', 'Ensemble de sites proposant des mls gratuits, des CHATs...');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(5, 'ACADEMIE', 't', 't', 'Ensemble de sites suggrs par la communaut ducative - vos suggestions');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(6, 'PUBLICITES', 't', 't', 'certaines bannires publicitaires connues seront remplaces par une image locale');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(7, 'ADRESSES IP', 't', 't', 'Les urls contenant des adresses IP seront interdites');
INSERT INTO "squidstatus" ("id", "nom", "actif", "tovalid", "desc") VALUES(2, 'ADULTES', 'f', 't', 'Sites  caractres pornographiques');


