
CREATE SEQUENCE "subnet_id" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1; 
CREATE SEQUENCE "bar_id" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1; 

/* -------------------------------------------------------- 
  Table structure for table "subnets" 
-------------------------------------------------------- */
CREATE TABLE "subnets" (
   "id" int4 DEFAULT nextval('subnet_id'::text) NOT NULL,
   "nom" varchar(30) NOT NULL,
   "network" varchar(15) NOT NULL,
   "netmask" varchar(15) NOT NULL,
   "status" bool,
   PRIMARY KEY ("id")
);
CREATE INDEX "id_subnets_key" ON "subnets" ("id");
CREATE INDEX "nom_subnets_key" ON "subnets" ("nom");
CREATE INDEX "status_subnets_key" ON "subnets" ("status");

/* -------------------------------------------------------- 
  Table structure for table "subnetstat" 
-------------------------------------------------------- */
CREATE TABLE "subnetstat" (
   "id" int4 DEFAULT nextval('bar_id'::text) NOT NULL,
   "subid" int4 NOT NULL,
   "actif" int4 NOT NULL,
   "inactif" int4 NOT NULL,
   "days" int4 NOT NULL,
   PRIMARY KEY ("id")
);
CREATE INDEX "id_subnetstat_key" ON "subnetstat" ("id");
CREATE INDEX "subid_subnetstat_key" ON "subnetstat" ("subid");
CREATE INDEX "days_subnetstat_key" ON "subnetstat" ("days");


/* ---------------------------------------------------------
   Change permissions  
--------------------------------------------------------- */
GRANT ALL on "subnets" to hadmin;
GRANT ALL on "subnetstat" to hadmin;
