/*
 * $Id: url_filters.sql,v 1.1 2003/12/22 13:43:00 bzizou Exp $
 * URL FILTER MODULE
 * SLIS project
 * This file is part of the SLIS Project initiated by the 
 * CARMI-Internet (Acadmie de Grenoble - France 38).
 *
 * Bruno@ac-grenoble.fr - (C)2003
 */

DROP SEQUENCE "uf_rule_id_seq";
DROP SEQUENCE "uf_baselist_id_seq";
DROP SEQUENCE "uf_base_id_seq";
DROP SEQUENCE "uf_url_id_seq";
DROP SEQUENCE "uf_domain_id_seq";
DROP SEQUENCE "uf_expression_id_seq";
CREATE SEQUENCE "uf_rule_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_baselist_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_base_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_url_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_domain_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;
CREATE SEQUENCE "uf_expression_id_seq" START 1 INCREMENT 1 MAXVALUE 9223372036854775807 MINVALUE 1 CACHE 1;

DROP TABLE "uf_rule";
CREATE TABLE "uf_rule" (
   "id" int4 DEFAULT nextval('"uf_rule_id_seq"'::text) NOT NULL,
   "name" varchar(128) NOT NULL,
   "network" varchar(128),
   "group" varchar(128)
);
CREATE  INDEX "uf_rule_id_key" ON "uf_rule" ("id");

DROP TABLE "uf_baselist";
CREATE TABLE "uf_baselist" (
   "id" int4 DEFAULT nextval('"uf_baselist_id_seq"'::text) NOT NULL,
   "type" varchar(128) NOT NULL,
   "rule" int4 NOT NULL,
   "base" int4 NOT NULL
);
CREATE  INDEX "uf_baselist_id_key" ON "uf_baselist" ("id");

DROP TABLE "uf_base";
CREATE TABLE "uf_base" (
   "id" int4 DEFAULT nextval('"uf_base_id_seq"'::text) NOT NULL,
   "name" varchar(128) NOT NULL,
   "type" varchar(32) NOT NULL,
   "comment" text
);
CREATE  INDEX "uf_base_id_key" ON "uf_base" ("id");

DROP TABLE "uf_url";
CREATE TABLE "uf_url" (
   "id" int4 DEFAULT nextval('"uf_url_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "url" text
);

DROP TABLE "uf_domain";
CREATE TABLE "uf_domain" (
   "id" int4 DEFAULT nextval('"uf_domain_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "domain" text
);

DROP TABLE "uf_expression";
CREATE TABLE "uf_expression" (
   "id" int4 DEFAULT nextval('"uf_expression_id_seq"'::text) NOT NULL,
   "base" int4 NOT NULL,
   "expression" text
);

INSERT INTO "uf_rule" ("name") VALUES('default');
INSERT INTO "uf_base" ("name","type","comment") VALUES('adult','predef','Sites a caractere pornographique');
INSERT INTO "uf_base" ("name","type","comment") VALUES('forums','predef','Forums');
INSERT INTO "uf_base" ("name","type","comment") VALUES('publicite','predef','Banieres de publicite');
INSERT INTO "uf_base" ("name","type","comment") VALUES('warez','predef','Sites de piratage');
INSERT INTO "uf_base" ("name","type","comment") VALUES('academie','predef','Base academique');
INSERT INTO "uf_base" ("name","type","comment") VALUES('in-addr','predef','Adresses ip');
INSERT INTO "uf_base" ("name","type","comment") VALUES('all','predef','Tout internet');
INSERT INTO "uf_baselist" ("type","rule","base") VALUES('block','1','3');
INSERT INTO "uf_baselist" ("type","rule","base") VALUES('pass','1','7');

GRANT ALL on "uf_rule" TO hadmin;
GRANT ALL on "uf_baselist" TO hadmin;
GRANT ALL on "uf_base" TO hadmin;
GRANT ALL on "uf_url" TO hadmin;
GRANT ALL on "uf_domain" TO hadmin;
GRANT ALL on "uf_expression" TO hadmin;
