#!/usr/bin/perl
# $Id: slis.pac,v 1.4 2003/12/12 14:57:35 bzizou Exp $

# This script creates a Proxy Automatic Configuration script for using
# with web browsers. It must be stored as a CGI on a http server running
# on the squid proxy.
# It automaticaly guesses what are the local hosts and the port squid is
# running on.

# This script is part of the SLIS Project initiated by the CARMI-Internet
# (Académie de Grenoble - France 38).
# Ce script fait partie du projet SLIS démarré par le CARMI-Internet
# (Académie de Grenoble - France 38).
#
# SLIS : Serveur de communications Linux Pour l'Internet Scolaire.
# Copyright (C) 1998-2003 Bruno Bzeznik
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    You should have received a copy of the GNU General Public License
#    along with this program (For example ./COPYING);
#    if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
#    Cambridge, MA 02139, USA.
#
# Please send all comments and bug reports by electronic mail to:
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# or to <slis@ac-grenoble.fr>
#
# Envoyez vos suggestions et reports de bugs par e-mail à
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# ou à <slis@ac-grenoble.fr>


use NetAddr::IP;

# Get the Browser's ip
$myad=$ENV{REMOTE_ADDR};

# Get the HOSTNAME and DOMAIN of the server
open(FILE,"/etc/HOSTNAME");
@HOST=<FILE>;
close FILE;
$HOSTLINE=$HOST[0];
chomp($HOSTLINE);
($HOSTNAME,$DOMAIN)=split(/\./,$HOSTLINE,2);

# Get all of the ip/mask of the server
@IPS=`ip addr show |grep inet`;

# Get the port of the proxy
$HTTP_PORT=`grep http_port /etc/squid/squid.conf`;
chomp($HTTP_PORT);
$_=$HTTP_PORT;
($http_port,$PORT)=split;

# Connection to the local server -> DIRECT
print "
function FindProxyForURL(url, host)
{
        if (dnsDomainIs(host, \"$HOSTNAME.$DOMAIN\") ||
                dnsDomainIs(host, \"$HOSTNAME\") ||
";

# Connection to a local host -> DIRECT
foreach (@IPS) {
  ($inet,$addr)=split;
  $space=new NetAddr::IP $addr or die
    "$addr is not a valid ip!\n";
  ($network,$bits)=split(/\//,$space->network);
  $mask=$space->mask;
  print "		isInNet(host, \"$network\", \"$mask\") ||\n";
}
print "		isInNet(host, \"127.0.0.0\", \"255.0.0.0\") ) {
		return  \"DIRECT\";
        }\n";


# Connection from a local host to something else -> PROXY
foreach (@IPS) {
  ($inet,$addr)=split;
  $space=new NetAddr::IP $addr or die
    "$addr is not a valid ip!\n";
  ($network,$bits)=split(/\//,$space->network);
  ($ip,$bits)=split(/\//,$addr);
  $mask=$space->mask;
  print "\n        else if (isInNet(\"$myad\", \"$network\", \"$mask\")) {
                return \"PROXY $ip:$PORT; DIRECT\";
        }";
}


# Connection from something else to something else -> DIRECT
print "
        else {
                return \"DIRECT\";
        }
}
";
